(** Float numbers. *)

module Make : Logic.T =
  struct
    include Logic.Default

    type t = float

    let top () = raise Not_found

    let bot () = raise Not_found

    let compare y1 y2 =
      if y1 < y2 then -1
      else if y1 > y2 then 1
      else 0

    let entails y1 y2 = y1 = y2

    let conj d1 d2 =
      if entails d1 d2 then d1
      else if entails d2 d1 then d2
      else raise Not_found

    let add d1 d2 = conj d1 d2

    let sub d1 d2 = if entails d1 d2 then raise Not_found else d1

    let features = function
      |	y -> []

    let gen d1 d2 ds = []

    open Token

    let parse = parser
      |	[<'Float (f,_)>] -> f

    let rec print = function
      |	f -> [Float (f, Token.prec_of_sfloat (string_of_float f))]

    let simpl _ = [<>]

  end
