(** Integer numbers. *)

module Make : Logic.T =
  struct
    include Logic.Default

    type t = int

    let isvalue _ = true

    let compare y1 y2 =
      if y1 < y2 then -1
      else if y1 > y2 then 1
      else 0

    let entails y1 y2 = y1 = y2

    let conj d1 d2 =
      if entails d1 d2 then d1
      else if entails d2 d1 then d2
      else raise Not_found

    let add d1 d2 = conj d1 d2

    let sub d1 d2 = if entails d1 d2 then raise Not_found else d1

    let features = function
      |	y -> []

    open Token

    let parse = parser
      |	[<'Int y>] -> y

    let rec print = function
      |	y -> [Int y]

  end 
